<template>
	<div class="common-page device-manage">

		<div class="option page-row">
			<!--工具栏-->
			<div class="head-container">
				<!-- 搜索 -->

				<label class="el-form-item-label" style="font-weight: 500;">人员姓名</label>
				<el-input v-model="query.name" clearable size="small" placeholder="请输入人员姓名" style="width:180px;"/>

				<label class="el-form-item-label" style="font-weight: 500;">驾驶车辆</label>
				<el-select v-model="query.car" placeholder="请选择驾驶车辆" style="width:180px;">
					<el-option v-for="(obj,index) in selectList" :label="obj.number" :value="obj.number" :key="index"></el-option>
				</el-select>

				<el-button size="mini" type="success" icon="el-icon-search" @click="toSearch">搜索</el-button>
				<el-button size="mini" icon="el-icon-refresh" @click="clearLimit">重置</el-button>
			</div>
		</div>

    	<!-- 表格 -->
		<div class="panel-bottom page-row">
			<h3>司机人员管理</h3>
			<div class="ctin-box">
				<div class="content-within">
					<div class="content-fix">
						<div class="toolbar">
							<el-button size="mini" type="primary" icon="el-icon-plus" @click="toAdd">新增</el-button>
						</div>
						<div class="content">
							<el-table :data="tableData" v-loading="loading" border style="width:auto" :row-class-name="tableRowClassName">
								<el-table-column prop="name" label="名称" align="center"></el-table-column>
								<el-table-column prop="userName" label="用户名" align="center"></el-table-column>
								<el-table-column prop="phone" label="电话" align="center"></el-table-column>
								<el-table-column prop="age" label="驾龄(年)" align="center"></el-table-column>
								<el-table-column prop="depart" label="部门" align="center"></el-table-column>
								<el-table-column prop="post" label="岗位" align="center"></el-table-column>
								<el-table-column prop="company" label="公司名称" align="center"></el-table-column>
								<el-table-column prop="adr" label="住址" align="center"></el-table-column>
								<el-table-column prop="car" label="驾驶车辆" align="center"></el-table-column>
								<el-table-column label="操作" align="center" fixed="right">
									<template slot-scope="scope">
										<el-button size="mini" type="primary" icon="el-icon-edit" @click="toEdit(scope.row)"></el-button>
										<el-button size="mini" type="danger" icon="el-icon-delete" @click="toDelete(scope.row)"></el-button>
									</template>
								</el-table-column>
							</el-table>
							<!--分页组件-->
							<el-pagination :total="total" :current-page="page" style="margin-top: 8px;" layout="total, prev, pager, next, sizes" @size-change="sizeChange" @current-change="pageChange" />
						</div>
					</div>
				</div>
			</div>
		</div>

		<!-- 表单渲染 -->
		<el-dialog append-to-body :close-on-click-modal="true" :before-close="cancelForm" :visible.sync="form.visible" :title="form.title" width="700px">
			<el-form :model="form.item" :rules="rules" ref="form1" :inline="true" size="small" label-width="150px">
				<el-form-item label="名称" prop="name">
					<el-input v-model="form.item.name" style="width:280px;" placeholder="请输入名称"/>
				</el-form-item>
				<el-form-item label="用户名" prop="userName">
					<el-select v-model="form.item.userName" placeholder="请选择用户名" style="width:280px;">
						<el-option v-for="(obj,index) in allSystemUserNameData" :label="obj.username" :value="obj.username" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="电话" prop="phone">
					<el-input v-model="form.item.phone" style="width:280px;" placeholder="请输入电话"/>
				</el-form-item>
				<el-form-item label="驾龄(年)" prop="age">
					<el-input v-model="form.item.age" style="width:280px;" placeholder="请输入驾龄"/>
				</el-form-item>
				<el-form-item label="部门" prop="depart">
					<el-select v-model="form.item.depart" placeholder="请选择部门" style="width:280px;">
						<el-option v-for="(obj,index) in allDepartmentData" :label="obj.name" :value="obj.name" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="岗位" prop="post">
					<el-select v-model="form.item.post" placeholder="请选择岗位" style="width:280px;">
						<el-option v-for="(obj,index) in allPostData" :label="obj.name" :value="obj.name" :key="index"></el-option>
					</el-select>
				</el-form-item>
				<el-form-item label="公司名称" prop="company">
					<el-input v-model="form.item.company" style="width:280px;" placeholder="请输入公司名称"/>
				</el-form-item>
				<el-form-item label="住址" prop="adr">
					<el-input v-model="form.item.adr" style="width:280px;" placeholder="请输入住址"/>
				</el-form-item>
				<el-form-item label="驾驶车辆" prop="car">
					<el-select v-model="form.item.car" placeholder="请选择驾驶车辆" style="width:280px;">
						<el-option v-for="(obj,index) in selectList" :label="obj.number" :value="obj.number" :key="index"></el-option>
					</el-select>
				</el-form-item>
			</el-form>
			<div slot="footer" class="dialog-footer">
				<el-button type="text" @click="cancelForm">取消</el-button>
				<el-button :loading="form.status.cu === 2" type="primary" @click="submitForm('form1', form.item)">确认</el-button>
			</div>
		</el-dialog>

	</div>
</template>

<script>
import { Tools, HttpReq, Dates} from '@/assets/js/common.js';

export default {
	name: 'DriverManage',
	components: {},
	data() {
		return {
			loading: false,
			page: 1,
			size: 10,
			total: 0,
			query:{},
			tableData: [],
			selectList:[],
			allSystemUserNameData:[],
			allDepartmentData:[],
			allPostData:[],
			form: {
				title:'新增司机人员',
				visible:false,
				reqType:'add',
				status:{cu:0},
				item:{},
			},
			rules: {
				// number: [
				// 	{required: true, message: '请输入车牌号', trigger: 'blur' }
				// ],
			},
		}
	},
	mounted() {
		var that = this;
		this.$nextTick(() => {
			this.loadData();
		})
	},
	methods: {
		loadData() {
			var sort = 'id,desc';
			var param = this.query;
			param.page = this.page - 1;
			param.size = this.size;
			param.sort = sort;
			
			this.$nextTick(()=>{
				//获取司机人员信息
				HttpReq.truckDispatching.driverManagementPCQuery(param).then((res) => {
					if(res.code == 200){
						this.loading = false;
						this.tableData = res.data.content;
						this.total = res.data.totalElements;
					}
				})
				//获取车辆信息
				HttpReq.truckDispatching.carInformationQuery({size:9999}).then((res) => {
					if(res.code == 200){
						this.selectList = res.data.content;
					}
				})
				//获取用于选择的用户名
				HttpReq.truckDispatching.getAllSystemUserNameQuery({size:9999}).then((res) => {
					this.allSystemUserNameData = res.content;
				})
				//获取用于选择的用户名
				HttpReq.truckDispatching.getAllDepartmentQuery({size:9999}).then((res) => {
					console.log(res);
					this.allDepartmentData = res.content;
				})
				//获取用于选择的用户名
				HttpReq.truckDispatching.getAllPostQuery({size:9999}).then((res) => {
					console.log(res);
					this.allPostData = res.content;
				})
			})

		},
		tableRowClassName({row, rowIndex}) {
			if (rowIndex === 1) {
				return 'warning-row';
			} else if (rowIndex === 3) {
				return 'success-row';
			}
			return '';
		},
		// 点击搜索
		toSearch() {
			this.page = 1;
			this.loadData();
		},
		// 重置搜索
		clearLimit(){
			this.query = {};
			this.loadData()
		},
		cancelForm(a, b, c){
			this.form.visible = false;
		},
		toAdd() {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '新增司机人员';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.reqType = 'add';
			this.form.item = {};
		},
		toEdit(item) {
			// 请除表单验证
			this.$refs['form1'] && this.$refs['form1'].clearValidate();
			this.form.title = '修改司机人员';
			this.form.status.cu = 0;
			this.form.visible = true;
			this.form.item = {...item};
			this.form.reqType = 'edit';
		},
		toDelete(item) {
			var id = item.id;
			this.$confirm('确认删除该条数据吗?', '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then((e) => {
				this.reqRemoveProject([id])
			}).catch((e) => {})
		},
		pageChange(e) {
			this.page = e
			this.loadData()
		},
		sizeChange(e) {
			this.page = 1
			this.size = e
			this.loadData()
		},
		submitForm(validateName, item){
			if(!this.form.status.cu){
				this.form.status.cu = 2;
				this.$refs[validateName].validate(valid => {
					if(valid){
						if(this.form.reqType === 'add'){
							this.reqAddItem(this.form, item)
						}else{
							this.reqUpdateItem(this.form, item)
						}
					}else{
						this.form.status.cu = 0
					}
				});
			};
		},
		//新增司机人员
		reqAddItem(form, item){
			let lastData = {...item};
			HttpReq.truckDispatching.driverManagementPCAdd(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '司机人员新增成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				form.status.cu = 0
			});
		},
		//修改司机人员
		reqUpdateItem(form, item){
			let lastData = {...item};
			HttpReq.truckDispatching.driverManagementPCUpdate(lastData).then((res) => {
				form.visible = false;
				if(res.code == 200){
					this.$notify({
						title: '司机人员修改成功！',
						type: 'success',
						duration: 2500
					});
					this.loadData()
				}else{
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}
			}).catch(function(error) {
				form.status.cu = 0
			});
		},
		//删除司机人员
		reqRemoveProject(item){
			HttpReq.truckDispatching.driverManagementPCDel(item).then((res) => {
				if(res.status == 400){
					this.$notify({
						title: res.msg,
						type: 'error',
						duration: 2500
					})
				}else{
					this.$notify({
						title: '删除成功！',
						type: 'success',
						duration: 2500
					});
				}
				this.loadData();
			})
		},
	}
}
</script>

<style rel="stylesheet/scss" lang="scss" scope>
	.el-table .warning-row {
		background: oldlace;
	}
	.el-table .success-row {
		background: #f0f9eb;
	}
	
	.device-manage{
		.panel-bottom{
			.el-button{margin:2px 0;padding:6px 15px;font-size:14px;}
			.btn-groub2{
				display:inline-block;
				.el-button{margin:2px 0;padding:6px 15px;font-size:15px;}
				.el-button--warning {
					background-color: #e6a23c;
					border-color: #e6a23c;
				}
				.el-button--warning:focus,.el-button--warning:hover{background:#ebb563;border-color:#ebb563;}
			}
		}
	}
	
	.ecahrt1-dialog{
		display:flex;align-items:center;
		.el-dialog{
			margin-top:inherit !important;display:table !important;width:fit-content;
			.el-form-item{margin-right:0;}
		}

		.el-dialog__header{height:0;padding:0;display:block;}
		.form-body{
			border:1px solid #999;width:800px;height:500px;position:relative;
			>div{position:absolute;top:0;left:0;height:100%;width:100%;}
		}
	}
</style>
